* memodemo.prg    test memo field editing
* 
* problem:        Foxbase Plus 2.1 doesn't allow for easy use of the
*                 memo field editor from within a program.
*
* logic:          this module is a sample editing session of
*                 testmemo.dbf which contains 4 fields, the 4th
*                 of which is a memofield, memfield.
*
*                 after editing other variables, user is prompted as
*                 to whether or not memo field editing is desired.
*
*                 if desired, memedit.fmt is created using the
*                 SET ALTERNATE commands, and then set as the format file.
*
*                 memedit.fmt:
*                                  @ 10, 10 say MSG
*                                  set color to ,b/b
*                                  @ 15,15 GET MEMFIELD   VALID MEMRET(.T.)
*                                  set color to ,n/w
*
*                 the initial "set color" statement sets foreground =
*                 background so that the "memo" block of the memo
*                 field is NOT displayed.  The second "set color"
*                 statement sets things back the way they were.
*
*                 the variable msg is initially defined as "",
*                 the nul string, as we
*                 want the user to get straight into the memo edit
*                 session.  Subsequently, however, msg is changed by
*                 the udf memret:
*
*                   PARA RET                
*                   MSG = "Press:  <Ctrl Pgdn> to resume editing or <ESC> to quit"
*                   RETURN RET
*
*                 The dummy variable ret is just used to fulfill syntax
*                 requirements of fb+ udf's.
*                 
*                 now, when the editing session is through, the user is
*                 returned to the format file screen with the read
*                 still active, but the prompt, msg, has been changed so
*                 that users now know they have the option to resume
*                 editing or quit.  Actually, any of the READKEY() keys
*                 will exit the editing, except the ctrl pgdn set.


* notice = "copyright (c) 1989  john m. bauman  all rights reserved"
* revisions:  1.0  11 february, 1989
*             1.1  12 february, 1989:  incorporated udf memret in
*                                      procedure file
*                                      create memedit.fmt "on the
*                                      fly"
*             1.2  23 april, 1989      simplify udf by passing a
*                                      logical .t. instead of a
*                                      variable defined as .t.
********************************************************************
* set up working environment:

SET STEP OFF
SET TALK OFF
SET HELP OFF
SET STAT OFF
SET SCOR OFF
SET SAFETY OFF
SET BELL OFF
SET DELI OFF
SET HEAD OFF
SET ECHO OFF
SET DEBUG OFF
SET TITLE OFF

SET COLOR TO W+/B,N/W,B

notice = "copyright (c) 1989  john m. bauman  all rights reserved"

SET PROCEDURE TO MEMODEMO

USE TESTMEMO            && .dbf containing memofield named memfield

IF RECCOUNT() = 0       && be sure we have a record to work with
   APPEND BLANK
ENDIF

SCATTER TO MEM          && sample non-memo fields

@ 3,20 SAY "MEMODEMO.PRG:  Demo of memo field editing"

@ 10,10 SAY "Enter character data:     " GET MEM(1)
@ 12,10 SAY "Enter numeric data:       " GET MEM(2)
@ 14,10 SAY "Enter logical data:       " GET MEM(3)
@ 23,10 SAY NOTICE

READ
GATHER FROM MEM

* prompt for editing of the memo field:

YN = "Y"
@ 16,10 SAY "Enter memo field data now, Y/N?" GET YN PICT "!" VALID YN $ "YN "
READ

IF YN = "Y"

   IF .NOT. FILE("MEMEDIT.FMT")
      * build a temporary .fmt file:

      SET CONSOLE OFF
      SET ALTERNATE TO MEMEDIT.FMT
      SET ALTERNATE ON
   
      ? "@ 10, 10 say MSG"
      ? "set color to ,b/b"
      ? "@ 15,15 GET MEMFIELD   VALID MEMRET(.T.)"
      ? "set color to ,n/w"

      SET ALTERNATE OFF
      SET ALTERNATE TO
      SET CONSOLE ON
   
   ENDIF .not. file("memedit.fmt")

   * stuff keyboard with <ctrl pgdn> to auto enter memo editing:

   KEYBOARD CHR(30)

   MSG = ""                && initially no message to display
   SAVE SCREEN             && optional save of previous screen

   SET FORMAT TO MEMEDIT   
   READ
   SET FORMAT TO
   
   RESTORE SCREEN          && optional screen restore

   WAIT                    && just a pause to show restored screen

ENDIF yn = "y"

CLEAR
SET PROCEDURE TO
! DEL MEMEDIT.FMT > NUL       && kill fmt file or comment this out and leave it
CLEAR ALL
RETURN
* eof() memodemo.prg
PROCEDURE MEMRET
**********************************************************
*                         UDF MEMRET()
**********************************************************
* memret.prg is a "dummy" udf in a valid clause for memo field
*            editing from a .fmt file.  the only purpose of this
*            valid clause is to change the value of the variable
*            msg from nul ("") to the message below, DURING A READ,
*            so that it may be displayed after editing the memo field
PARA RET
MSG = "Press:  <Ctrl Pgdn> to resume editing or <ESC> to quit"
RETURN RET  && .T.
* eof() memret.prg/udf
* eop() memodemo.prg
